@use "../sable";

.font-sans {
  @include sable.typo-sans-serif-font();
}
.font-serif {
  @include sable.typo-serif-font();
}
.font-mono {
  @include sable.typo-mono-font();
}
.font-inherit {
  @include sable.typo-inherit-font();
}

.font-thin,
.hover\:font-thin:hover {
  @include sable.typo-font-weight(100);
}
.font-extralight,
.hover\:font-extralight:hover {
  @include sable.typo-font-weight(200);
}
.font-light,
.hover\:font-light:hover {
  @include sable.typo-font-weight(300);
}
.font-normal,
.hover\:font-normal:hover {
  @include sable.typo-font-weight(400);
}
.font-medium,
.hover\:font-medium:hover {
  @include sable.typo-font-weight(500);
}
.font-semibold,
.hover\:font-semibold:hover {
  @include sable.typo-font-weight(600);
}
.font-bold,
.hover\:font-bold:hover {
  @include sable.typo-font-weight(700);
}
.font-extrabold,
.hover\:font-extrabold:hover {
  @include sable.typo-font-weight(800);
}
.font-black,
.hover\:font-black:hover {
  @include sable.typo-font-weight(900);
}

.italic,
.hover\:italic:hover {
  @include sable.typo-font-style(italic);
}
.not-italic,
.hover\:not-italic:hover {
  @include sable.typo-font-style(normal);
}

$font-size-xs  : .75rem !default;
$font-size-sm  : .875rem !default;
$font-size-base: 1rem !default;
$font-size-md  : 1.25rem !default;
$font-size-lg  : 1.5rem !default;
$font-size-xl  : 2rem !default;
$font-size-2xl : 2.5rem !default;
$font-size-3xl : 3rem !default;
$font-size-4xl : 3.5rem !default;
$font-size-5xl : 4rem !default;

.text-xs {
  @include sable.typo-font-size($font-size-xs);
}
.text-sm {
  @include sable.typo-font-size($font-size-sm);
}
.text-base {
  @include sable.typo-font-size($font-size-base);
}
.text-md {
  @include sable.typo-font-size($font-size-md);
}
.text-lg {
  @include sable.typo-font-size($font-size-lg);
}
.text-xl {
  @include sable.typo-font-size($font-size-xl);
}
.text-2xl {
  @include sable.typo-font-size($font-size-2xl);
}
.text-3xl {
  @include sable.typo-font-size($font-size-3xl);
}
.text-4xl {
  @include sable.typo-font-size($font-size-4xl);
}
.text-5xl {
  @include sable.typo-font-size($font-size-5xl);
}

$line-height-none   : 1 !default;
$line-height-tight  : 1.25 !default;
$line-height-snug   : 1.375 !default;
$line-height-normal : 1.5 !default;
$line-height-relaxed: 1.625 !default;
$line-height-loose  : 2 !default;

.leading-none {
  @include sable.typo-line-height($line-height-none);
}
.leading-tight {
  @include sable.typo-line-height($line-height-tight);
}
.leading-snug {
  @include sable.typo-line-height($line-height-snug);
}
.leading-normal {
  @include sable.typo-line-height($line-height-normal);
}
.leading-relaxed {
  @include sable.typo-line-height($line-height-relaxed);
}
.leading-loose {
  @include sable.typo-line-height($line-height-loose);
}

$letter-spacing-tighter: -.05em !default;
$letter-spacing-tight  : -.025em !default;
$letter-spacing-normal : 0em !default;
$letter-spacing-wide   : .025em !default;
$letter-spacing-wider  : .05em !default;
$letter-spacing-widest : .1em !default;

.tracking-tighter,
.hover\:tracking-tighter:hover,
.focus\:tracking-tighter:focus {
  @include sable.typo-letter-spacing($letter-spacing-tighter);
}
.tracking-tight,
.hover\:tracking-tight:hover,
.focus\:tracking-tight:focus {
  @include sable.typo-letter-spacing($letter-spacing-tight);
}
.tracking-normal,
.hover\:tracking-normal:hover,
.focus\:tracking-normal:focus {
  @include sable.typo-letter-spacing($letter-spacing-normal);
}
.tracking-wide,
.hover\:tracking-wide:hover,
.focus\:tracking-wide:focus {
  @include sable.typo-letter-spacing($letter-spacing-wide);
}
.tracking-wider,
.hover\:tracking-wider:hover,
.focus\:tracking-wider:focus {
  @include sable.typo-letter-spacing($letter-spacing-wider);
}
.tracking-widest,
.hover\:tracking-widest:hover,
.focus\:tracking-widest:focus {
  @include sable.typo-letter-spacing($letter-spacing-widest);
}

.text-shadow-none,
.hover\:text-shadow-none:hover,
.focus\:text-shadow-none:focus {
  @include sable.typo-text-shadow(none);
}

.text-fill-transparent {
  @include sable.typo-text-fill-color(transparent);
}

.normal-nums {
  @include sable.typo-font-variant-numeric(normal);
}
.ordinal {
  @include sable.typo-font-variant-numeric(ordinal);
}
.slashed-zero {
  @include sable.typo-font-variant-numeric(slashed-zero);
}
.lining-nums {
  @include sable.typo-font-variant-numeric(lining-nums);
}
.oldstyle-nums {
  @include sable.typo-font-variant-numeric(oldstyle-nums);
}
.proportional-nums {
  @include sable.typo-font-variant-numeric(proportional-nums);
}
.tabular-nums {
  @include sable.typo-font-variant-numeric(tabular-nums);
}
.diagonal-fractions {
  @include sable.typo-font-variant-numeric(diagonal-fractions);
}
.stacked-fractions {
  @include sable.typo-font-variant-numeric(stacked-fractions);
}

.list-none {
  @include sable.typo-list-style-none();
}

.list-inside {
  @include sable.typo-list-style-position(inside);
}
.list-outside {
  @include sable.typo-list-style-position(outside);
}

.list-disc {
  @include sable.typo-list-style-type(disc);
}
.list-decimal {
  @include sable.typo-list-style-type(decimal);
}

.text-right {
  @include sable.typo-text-align(right);
}
.text-center {
  @include sable.typo-text-align(center);
}
.text-left {
  @include sable.typo-text-align(left);
}
.text-justify {
  @include sable.typo-text-align(justify);
}

.decoration-none,
.hover\:decoration-none:hover,
.focus\:decoration-none:focus {
  @include sable.typo-text-decoration(none);
}

.no-underline,
.hover\:no-underline:hover,
.focus\:no-underline:focus {
  @include sable.typo-text-decoration-line(none);
}
.underline,
.hover\:underline:hover,
.focus\:underline:focus {
  @include sable.typo-text-decoration-line(underline);
}
.overline,
.hover\:overline:hover,
.focus\:overline:focus {
  @include sable.typo-text-decoration-line(overline);
}
.line-through,
.hover\:line-through:hover,
.focus\:line-through:focus {
  @include sable.typo-text-decoration-line(line-through);
}

.decoration-solid,
.hover\:decoration-solid:hover,
.focus\:decoration-solid:focus {
  @include sable.typo-text-decoration-style(solid);
}
.decoration-double,
.hover\:decoration-double:hover,
.focus\:decoration-double:focus {
  @include sable.typo-text-decoration-style(double);
}
.decoration-dotted,
.hover\:decoration-dotted:hover,
.focus\:decoration-dotted:focus {
  @include sable.typo-text-decoration-style(dotted);
}
.decoration-dashed,
.hover\:decoration-dashed:hover,
.focus\:decoration-dashed:focus {
  @include sable.typo-text-decoration-style(dashed);
}
.decoration-wavy,
.hover\:decoration-wavy:hover,
.focus\:decoration-wavy:focus {
  @include sable.typo-text-decoration-style(wavy);
}

.uppercase,
.hover\:uppercase:hover,
.focus\:uppercase:focus {
  @include sable.typo-text-transform(uppercase);
}
.lowercase,
.hover\:lowercase:hover,
.focus\:lowercase:focus {
  @include sable.typo-text-transform(lowercase);
}
.capitalize,
.hover\:capitalize:hover,
.focus\:capitalize:focus {
  @include sable.typo-text-transform(capitalize);
}

.text-truncate,
.hover\:text-truncate:hover,
.focus\:text-truncate:focus {
  @include sable.layo-overflow(hidden);
  @include sable.typo-text-overflow(ellipsis);
  @include sable.typo-white-space(nowrap);
}
.text-ellipsis,
.hover\:text-ellipsis:hover,
.focus\:text-ellipsis:focus {
  @include sable.typo-text-overflow(ellipsis);
}
.text-clip,
.hover\:text-clip:hover,
.focus\:text-clip:focus {
  @include sable.typo-text-overflow(clip);
}

.vertical-baseline,
.before\:vertical-baseline::before,
.after\:vertical-baseline::after {
  @include sable.typo-vertical-align(baseline);
}
.vertical-top,
.before\:vertical-top::before,
.after\:vertical-top::after {
  @include sable.typo-vertical-align(top);
}
.vertical-middle,
.before\:vertical-middle::before,
.after\:vertical-middle::after {
  @include sable.typo-vertical-align(middle);
}
.vertical-bottom,
.before\:vertical-bottom::before,
.after\:vertical-bottom::after {
  @include sable.typo-vertical-align(bottom);
}
.vertical-text-top,
.before\:vertical-text-top::before,
.after\:vertical-text-top::after {
  @include sable.typo-vertical-align(text-top);
}
.vertical-text-bottom,
.before\:vertical-text-bottom::before,
.after\:vertical-text-bottom:after {
  @include sable.typo-vertical-align(text-bottom);
}
.vertical-sub,
.before\:vertical-sub::before,
.after\:vertical-sub::after {
  @include sable.typo-vertical-align(sub);
}
.vertical-super,
.before\:vertical-super::before,
.after\:vertical-super::after {
  @include sable.typo-vertical-align(super);
}

.whitespace-nowrap {
  @include sable.typo-white-space(nowrap);
}
.whitespace-pre {
  @include sable.typo-white-space(pre);
}
.whitespace-pre-line {
  @include sable.typo-white-space(pre-line);
}
.whitespace-pre-wrap {
  @include sable.typo-white-space(pre-wrap);
}

.break-normal {
  @include sable.layo-overflow-with(wrap, normal);
  @include sable.typo-word-break(normal);
}
.break-words{
  @include sable.layo-overflow-with(wrap, break-word);
}
.break-all {
  @include sable.typo-word-break(break-all);
}
.break-keep {
  @include sable.typo-word-break(keep-all);
}

.hyphens-none {
  @include sable.typo-hyphens(none);
}
.hyphens-manual {
  @include sable.typo-hyphens(manual);
}
.hyphens-auto {
  @include sable.typo-hyphens(auto);
}

.content-none,
.before\:content-none::before,
.after\:content-none::after {
  @include sable.typo-content(none);
}

.content-blank,
.before\:content-blank::before,
.after\:content-blank::after {
  @include sable.typo-content('');
}

@for $i from 1 through 20 {
  $half-perc: $i * 5;
  .opacity-#{$half-perc} {
    @include sable.typo-opacity(sable.fun-math-div($half-perc, 100));
  }
}
.opacity-0 {
  @include sable.typo-opacity(0);
}

@each $bpName, $width in sable.$fun-breakpoints {
  @media (min-width: #{$width}) {
    .#{$bpName}\:font-thin,
    .#{$bpName}\:hover\:font-thin:hover {
      @include sable.typo-font-weight(100);
    }
    .#{$bpName}\:font-extralight,
    .#{$bpName}\:hover\:font-extralight:hover {
      @include sable.typo-font-weight(200);
    }
    .#{$bpName}\:font-light,
    .#{$bpName}\:hover\:font-light:hover {
      @include sable.typo-font-weight(300);
    }
    .#{$bpName}\:font-normal,
    .#{$bpName}\:hover\:font-normal:hover {
      @include sable.typo-font-weight(400);
    }
    .#{$bpName}\:font-medium,
    .#{$bpName}\:hover\:font-medium:hover {
      @include sable.typo-font-weight(500);
    }
    .#{$bpName}\:font-semibold,
    .#{$bpName}\:hover\:font-semibold:hover {
      @include sable.typo-font-weight(600);
    }
    .#{$bpName}\:font-bold,
    .#{$bpName}\:hover\:font-bold:hover {
      @include sable.typo-font-weight(700);
    }
    .#{$bpName}\:font-extrabold,
    .#{$bpName}\:hover\:font-extrabold:hover {
      @include sable.typo-font-weight(800);
    }
    .#{$bpName}\:font-black,
    .#{$bpName}\:hover\:font-black:hover {
      @include sable.typo-font-weight(900);
    }
    
    .#{$bpName}\:italic {
      @include sable.typo-font-style(italic);
    }
    .#{$bpName}\:not-italic {
      @include sable.typo-font-style(normal);
    }
    
    .#{$bpName}\:text-xs {
      @include sable.typo-font-size($font-size-xs);
    }
    .#{$bpName}\:text-sm {
      @include sable.typo-font-size($font-size-sm);
    }
    .#{$bpName}\:text-base {
      @include sable.typo-font-size($font-size-base);
    }
    .#{$bpName}\:text-md {
      @include sable.typo-font-size($font-size-md);
    }
    .#{$bpName}\:text-lg {
      @include sable.typo-font-size($font-size-lg);
    }
    .#{$bpName}\:text-xl {
      @include sable.typo-font-size($font-size-xl);
    }
    .#{$bpName}\:text-2xl {
      @include sable.typo-font-size($font-size-2xl);
    }
    .#{$bpName}\:text-3xl {
      @include sable.typo-font-size($font-size-3xl);
    }
    .#{$bpName}\:text-4xl {
      @include sable.typo-font-size($font-size-4xl);
    }
    .#{$bpName}\:text-5xl {
      @include sable.typo-font-size($font-size-5xl);
    }
    
    .#{$bpName}\:leading-none {
      @include sable.typo-line-height($line-height-none);
    }
    .#{$bpName}\:leading-tight {
      @include sable.typo-line-height($line-height-tight);
    }
    .#{$bpName}\:leading-snug {
      @include sable.typo-line-height($line-height-snug);
    }
    .#{$bpName}\:leading-normal {
      @include sable.typo-line-height($line-height-normal);
    }
    .#{$bpName}\:leading-relaxed {
      @include sable.typo-line-height($line-height-relaxed);
    }
    .#{$bpName}\:leading-loose {
      @include sable.typo-line-height($line-height-loose);
    }
    
    .#{$bpName}\:tracking-tighter,
    .#{$bpName}\:hover\:tracking-tighter:hover,
    .#{$bpName}\:focus\:tracking-tighter:focus {
      @include sable.typo-letter-spacing($letter-spacing-tighter);
    }
    .#{$bpName}\:tracking-tight,
    .#{$bpName}\:hover\:tracking-tight:hover,
    .#{$bpName}\:focus\:tracking-tight:focus {
      @include sable.typo-letter-spacing($letter-spacing-tight);
    }
    .#{$bpName}\:tracking-normal,
    .#{$bpName}\:hover\:tracking-normal:hover,
    .#{$bpName}\:focus\:tracking-normal:focus {
      @include sable.typo-letter-spacing($letter-spacing-normal);
    }
    .#{$bpName}\:tracking-wide,
    .#{$bpName}\:hover\:tracking-wide:hover,
    .#{$bpName}\:focus\:tracking-wide:focus {
      @include sable.typo-letter-spacing($letter-spacing-wide);
    }
    .#{$bpName}\:tracking-wider,
    .#{$bpName}\:hover\:tracking-wider:hover,
    .#{$bpName}\:focus\:tracking-wider:focus {
      @include sable.typo-letter-spacing($letter-spacing-wider);
    }
    .#{$bpName}\:tracking-widest,
    .#{$bpName}\:hover\:tracking-widest:hover,
    .#{$bpName}\:focus\:tracking-widest:focus {
      @include sable.typo-letter-spacing($letter-spacing-widest);
    }
    
    .#{$bpName}\:text-right {
      @include sable.typo-text-align(right);
    }
    .#{$bpName}\:text-center {
      @include sable.typo-text-align(center);
    }
    .#{$bpName}\:text-left {
      @include sable.typo-text-align(left);
    }
    .#{$bpName}\:text-justify {
      @include sable.typo-text-align(justify);
    }
    
    .#{$bpName}\:decoration-none,
    .#{$bpName}\:hover\:decoration-none:hover,
    .#{$bpName}\:focus\:decoration-none:focus {
      @include sable.typo-text-decoration(none);
    }
    
    .#{$bpName}\:no-underline,
    .#{$bpName}\:hover\:no-underline:hover,
    .#{$bpName}\:focus\:no-underline:focus {
      @include sable.typo-text-decoration-line(none);
    }
    .#{$bpName}\:underline,
    .#{$bpName}\:hover\:underline:hover,
    .#{$bpName}\:focus\:underline:focus {
      @include sable.typo-text-decoration-line(underline);
    }
    .#{$bpName}\:overline,
    .#{$bpName}\:hover\:overline:hover,
    .#{$bpName}\:focus\:overline:focus {
      @include sable.typo-text-decoration-line(overline);
    }
    .#{$bpName}\:line-through,
    .#{$bpName}\:hover\:line-through:hover,
    .#{$bpName}\:focus\:line-through:focus {
      @include sable.typo-text-decoration-line(line-through);
    }
    
    .#{$bpName}\:decoration-solid,
    .#{$bpName}\:hover\:decoration-solid:hover,
    .#{$bpName}\:focus\:decoration-solid:focus {
      @include sable.typo-text-decoration-style(solid);
    }
    .#{$bpName}\:decoration-double,
    .#{$bpName}\:hover\:decoration-double:hover,
    .#{$bpName}\:focus\:decoration-double:focus {
      @include sable.typo-text-decoration-style(double);
    }
    .#{$bpName}\:decoration-dotted,
    .#{$bpName}\:hover\:decoration-dotted:hover,
    .#{$bpName}\:focus\:decoration-dotted:focus {
      @include sable.typo-text-decoration-style(dotted);
    }
    .#{$bpName}\:decoration-dashed,
    .#{$bpName}\:hover\:decoration-dashed:hover,
    .#{$bpName}\:focus\:decoration-dashed:focus {
      @include sable.typo-text-decoration-style(dashed);
    }
    .#{$bpName}\:decoration-wavy,
    .#{$bpName}\:hover\:decoration-wavy:hover,
    .#{$bpName}\:focus\:decoration-wavy:focus {
      @include sable.typo-text-decoration-style(wavy);
    }
    
    .#{$bpName}\:uppercase,
    .#{$bpName}\:hover\:uppercase:hover,
    .#{$bpName}\:focus\:uppercase:focus {
      @include sable.typo-text-transform(uppercase);
    }
    .#{$bpName}\:lowercase,
    .#{$bpName}\:hover\:lowercase:hover,
    .#{$bpName}\:focus\:lowercase:focus {
      @include sable.typo-text-transform(lowercase);
    }
    .#{$bpName}\:capitalize,
    .#{$bpName}\:hover\:capitalize:hover,
    .#{$bpName}\:focus\:capitalize:focus {
      @include sable.typo-text-transform(capitalize);
    }
    
    .#{$bpName}\:text-truncate,
    .#{$bpName}\:hover\:text-truncate:hover,
    .#{$bpName}\:focus\:text-truncate:focus {
      @include sable.layo-overflow(hidden);
      @include sable.typo-text-overflow(ellipsis);
      @include sable.typo-white-space(nowrap);
    }
    .#{$bpName}\:text-ellipsis,
    .#{$bpName}\:hover\:text-ellipsis:hover,
    .#{$bpName}\:focus\:text-ellipsis:focus {
      @include sable.typo-text-overflow(ellipsis);
    }
    .#{$bpName}\:text-clip,
    .#{$bpName}\:hover\:text-clip:hover,
    .#{$bpName}\:focus\:text-clip:focus {
      @include sable.typo-text-overflow(clip);
    }
    
    .#{$bpName}\:vertical-baseline,
    .#{$bpName}\:before\:vertical-baseline::before,
    .#{$bpName}\:after\:vertical-baseline::after {
      @include sable.typo-vertical-align(baseline);
    }
    .#{$bpName}\:vertical-top,
    .#{$bpName}\:before\:vertical-top::before,
    .#{$bpName}\:after\:vertical-top::after {
      @include sable.typo-vertical-align(top);
    }
    .#{$bpName}\:vertical-middle,
    .#{$bpName}\:before\:vertical-middle::before,
    .#{$bpName}\:after\:vertical-middle::after {
      @include sable.typo-vertical-align(middle);
    }
    .#{$bpName}\:vertical-bottom,
    .#{$bpName}\:before\:vertical-bottom::before,
    .#{$bpName}\:after\:vertical-bottom::after {
      @include sable.typo-vertical-align(bottom);
    }
    .#{$bpName}\:vertical-text-top,
    .#{$bpName}\:before\:vertical-text-top::before,
    .#{$bpName}\:after\:vertical-text-top::after {
      @include sable.typo-vertical-align(text-top);
    }
    .#{$bpName}\:vertical-text-bottom,
    .#{$bpName}\:before\:vertical-text-bottom::before,
    .#{$bpName}\:after\:vertical-text-bottom::after {
      @include sable.typo-vertical-align(text-bottom);
    }
    .#{$bpName}\:vertical-sub,
    .#{$bpName}\:before\:vertical-sub::before,
    .#{$bpName}\:after\:vertical-sub::after {
      @include sable.typo-vertical-align(sub);
    }
    .#{$bpName}\:vertical-super,
    .#{$bpName}\:before\:vertical-super::before,
    .#{$bpName}\:after\:vertical-super::after {
      @include sable.typo-vertical-align(super);
    }
    
    .#{$bpName}\:whitespace-nowrap {
      @include sable.typo-white-space(nowrap);
    }
    .#{$bpName}\:whitespace-pre {
      @include sable.typo-white-space(pre);
    }
    .#{$bpName}\:whitespace-pre-line {
      @include sable.typo-white-space(pre-line);
    }
    .#{$bpName}\:whitespace-pre-wrap {
      @include sable.typo-white-space(pre-wrap);
    }
    
    .#{$bpName}\:break-normal {
      @include sable.layo-overflow-with(wrap, normal);
      @include sable.typo-word-break(normal);
    }
    .#{$bpName}\:break-words{
      @include sable.layo-overflow-with(wrap, break-word);
    }
    .#{$bpName}\:break-all {
      @include sable.typo-word-break(break-all);
    }
    .#{$bpName}\:break-keep {
      @include sable.typo-word-break(keep-all);
    }
  }
}
